#!/usr/bin/env python2

import time
import rgma
import getopt
import rgmaqueryiter


class JobStatusMon(rgmaqueryiter.DetailedQuery):
    def __init__(self, tables=["JobStatusRaw"], filters=[""], type="LATEST" ):
    
        """parameters:
            query   -(SQL query to use)
            type    -(can be LATEST/CONTINUOUS/HISTORY/NOTIFY)
                attributes:
            instance  --(consumer created)
            """
                
        #*******Creating consumer  ********
        rgmaqueryiter.DetailedQuery.__init__( self, tables, filters=filters, type=type, timeout=3600, termination=3600 )



    def jobStatus(self):
        #******  If query is LATEST *********

        for result in self:
            status=result[2]
            return status
            
        return None               


    def jobStatusCon(self):
        
        #******** If query is CONTINUOUS  *********
        print            
        print "Starting CONTINUOUS query..."
        print "Enter Ctrl-C to stop"
        print
                    
        time.sleep(15)
        counter=1
        current_status=None
        try:
            # Termination condition makes sense only in case of job-status query
            # Otherwise (job-monitor) it means an eternal loop 
            # in this case the 2nd field of the tuple doesn't record the job status
            while current_status!="Done" and current_status!="Aborted" \
               and current_status!="Cleared":
                rs=None
                if self.count() > 0:
                    for rs in self:
                        current_status=rs[2]
                        print "event: %i" % counter
                        print rs
                        counter += 1
                        if self.count() == 0:
                            break
                if not rs:
                    print "No events"
                time.sleep(5)
                print
                    
            if current_status=="Done":
                print "Job is successfully done"
            elif current_status=="Aborted":
                print "Job is aborted"
            elif current_status=="Cleared":
                print "Job output is collected"
            print  
                    

        except KeyboardInterrupt:
            print "Interrupt (Ctrl-C) - exiting"
            self.__close__()
            return
    

    def jobStatusHis(self):
        
        #*********  If query is History *********
        

        try:
            print        
            print "Starting HISTORY query....."
            print

            counter=1
            time.sleep(15)
            for rs in self:
                print "event: %i" % counter 
                print rs
                counter += 1
                print
                time.sleep(0.5)
            if counter==1:
                print "No events"
                print
                            
        except KeyboardInterrupt:
            print "Interrupt (Ctrl-C) - exiting"
            self.__close__()
            return
            

    def jobStatusNotify(self,current_status):
        
        #***** If query is NOTIFY (CONTINUOUS)  *******
        
        try:
            print
            print "Current_status: ",current_status                       
            print
            while current_status!="Done" and current_status!="Aborted" \
               and current_status!="Cleared":
                for rs in self:
                    status=rs[2]
                    if status!=current_status:
                        print "New_status: ",status
                        current_status=status
                        break
                            
                if current_status=="Done":
                    print "Job is successfully terminated"
                elif current_status=="Aborted":
                    print "Job is aborted"
                elif current_status=="Cleared":
                    print "Job output is collected"
            print  
                            
        except KeyboardInterrupt:
            print "Interrupt (Ctrl-C) - exiting"
            self.__close__()
            return
                        

    def jobLatestInfo(self):
        #******  If query is LATEST *********
        print
        print "Starting Latest query..."
        print
                
        time.sleep(10)
        counter=1
        for rs in self:
            print "event: %i " % counter
            print rs
            counter += 1
            time.sleep(1)
            print
                                                              
        print "No more events"
        print
                                                                                

    
